Summary:	A C++ interface for glib library - cross MinGW32 version
Summary(pl.UTF-8):	Interfejs C++ dla biblioteki glib - wersja skrośna MinGW32
%define		realname	glibmm
Name:		crossmingw32-%{realname}
Version:	2.66.6
Release:	1
License:	LGPL v2+
Group:		Development/Libraries
Source0:	https://download.gnome.org/sources/glibmm/2.66/%{realname}-%{version}.tar.xz
# Source0-md5:	6defa41dd789059e57b0b417c36c004f
Patch0:		glibmm-mingw32.patch
URL:		https://www.gtkmm.org/
BuildRequires:	autoconf >= 2.59
BuildRequires:	automake >= 1:1.11
BuildRequires:	crossmingw32-gcc-c++ >= 1:4.7
BuildRequires:	crossmingw32-glib2 >= 2.62.0
BuildRequires:	crossmingw32-libsigc++ >= 2.10.0
BuildRequires:	crossmingw32-std-threads
BuildRequires:	libtool >= 2:2.0
BuildRequires:	m4
BuildRequires:	mm-common >= 0.9.10
BuildRequires:	perl-XML-Parser
BuildRequires:	perl-base
BuildRequires:	pkgconfig >= 1:0.15
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	crossmingw32-gcc-c++ >= 1:4.7
Requires:	crossmingw32-glib2 >= 2.62.0
Requires:	crossmingw32-libsigc++ >= 2.10.0
Requires:	crossmingw32-std-threads
ExcludeArch:	i386
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_strip	1
%define		_enable_debug_packages	0

%define		target			i386-mingw32
%define		target_platform 	i386-pc-mingw32

%define		_sysprefix		/usr
%define		_prefix			%{_sysprefix}/%{target}
%define		_libdir			%{_prefix}/lib
%define		_pkgconfigdir		%{_prefix}/lib/pkgconfig
%define		_dlldir			/usr/share/wine/windows/system
%define		__cc			%{target}-gcc
%define		__cxx			%{target}-g++
%define		__pkgconfig_provides	%{nil}
%define		__pkgconfig_requires	%{nil}

%ifnarch %{ix86}
# arch-specific flags (like alpha's -mieee) are not valid for i386 gcc
# now at least i486 is required for atomic operations
%define		optflags	-O2 -march=i486
%endif
# -z options are invalid for mingw linker, most of -f options are Linux-specific
%define		filterout_ld	-Wl,-z,.*
%define		filterout_c	-f[-a-z0-9=]*
%define		filterout_cxx	-f[-a-z0-9=]*

%description
A C++ interface for glib library - cross MinGW32 version.

%description -l pl.UTF-8
Interfejs C++ dla biblioteki glib - wersja skrośna MinGW32.

%package static
Summary:	Static glibmm library (cross MinGW32 version)
Summary(pl.UTF-8):	Statyczna biblioteka glibmm (wersja skrośna MinGW32)
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description static
Static glibmm library (cross MinGW32 version).

%description static -l pl.UTF-8
Statyczna biblioteka glibmm (wersja skrośna MinGW32).

%package dll
Summary:	DLL glibmm library for Windows
Summary(pl.UTF-8):	Biblioteka DLL glibmm dla Windows
Group:		Applications/Emulators
Requires:	crossmingw32-glib2-dll >= 2.62.0
Requires:	crossmingw32-libsigc++-dll >= 2.10.0
Requires:	wine

%description dll
DLL glibmm library for Windows.

%description dll -l pl.UTF-8
Biblioteka DLL glibmm dla Windows.

%prep
%setup -q -n %{realname}-%{version}
%patch0 -p1

%build
export PKG_CONFIG_LIBDIR=%{_prefix}/lib/pkgconfig
mm-common-prepare --copy --force
%{__libtoolize}
%{__aclocal} -I build
%{__autoconf}
%{__autoheader}
%{__automake}
# std-threads require at least WinXP API
CPPFLAGS="%{rpmcppflags} -DWINVER=0x0501"
# mingw32 requires gnu++11 (instead of c++11) for off[64]_t
CXXFLAGS="%{rpmcxxflags} -std=gnu++11"
%configure \
	--target=%{target} \
	--host=%{target} \
	--disable-documentation \
	--enable-maintainer-mode \
	--disable-silent-rules \
	--enable-static

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{_dlldir}
%{__mv} $RPM_BUILD_ROOT%{_prefix}/bin/*.dll $RPM_BUILD_ROOT%{_dlldir}

%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.la

%if 0%{!?debug:1}
%{target}-strip --strip-unneeded -R.comment -R.note $RPM_BUILD_ROOT%{_dlldir}/*.dll
%{target}-strip -g -R.comment -R.note $RPM_BUILD_ROOT%{_libdir}/*.a
%endif

# use these from native glibmm if needed
%{__rm} -r $RPM_BUILD_ROOT%{_libdir}/glibmm-2.4/proc

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README.md
%{_libdir}/libgiomm-2.4.dll.a
%{_libdir}/libglibmm-2.4.dll.a
%{_libdir}/libglibmm_generate_extra_defs-2.4.dll.a
%dir %{_libdir}/giomm-2.4
%{_libdir}/giomm-2.4/include
%dir %{_libdir}/glibmm-2.4
%{_libdir}/glibmm-2.4/include
%{_includedir}/giomm-2.4
%{_includedir}/glibmm-2.4
%{_pkgconfigdir}/giomm-2.4.pc
%{_pkgconfigdir}/glibmm-2.4.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libgiomm-2.4.a
%{_libdir}/libglibmm-2.4.a
%{_libdir}/libglibmm_generate_extra_defs-2.4.a

%files dll
%defattr(644,root,root,755)
%{_dlldir}/libgiomm-2.4-1.dll
%{_dlldir}/libglibmm-2.4-1.dll
%{_dlldir}/libglibmm_generate_extra_defs-2.4-1.dll
%changelog
* Wed Mar 15 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/crossmingw32-glibmm.git;a=log;h=master

* Wed Mar 15 2023 Jakub Bogusz <qboosh@pld-linux.org> 441179c
- updated to 2.66.6

* Fri Sep 23 2022 Jakub Bogusz <qboosh@pld-linux.org> c480002
- updated to 2.66.5

* Wed May 04 2022 Jakub Bogusz <qboosh@pld-linux.org> 458a4ec
- updated to 2.66.4 (ABI breakage fix)

* Wed May 04 2022 Jakub Bogusz <qboosh@pld-linux.org> 2e01056
- updated to 2.66.3

* Wed Oct 06 2021 Jakub Bogusz <qboosh@pld-linux.org> 990b407
- updated to 2.66.2

* Sat May 22 2021 Jakub Bogusz <qboosh@pld-linux.org> 3667c1c
- disable debug packages

* Sat May 22 2021 Jakub Bogusz <qboosh@pld-linux.org> a2ce3d2
- updated to 2.66.1

* Thu Jan 28 2021 Jakub Bogusz <qboosh@pld-linux.org> 7e0f286
- updated to 2.66.0

* Tue Dec 01 2020 Jakub Bogusz <qboosh@pld-linux.org> 35d99d1
- updated to 2.64.5

* Sun Nov 22 2020 Jakub Bogusz <qboosh@pld-linux.org> 2a6d148
- updated to 2.64.4

* Wed Apr 15 2020 Jakub Bogusz <qboosh@pld-linux.org> 98f0b9c
- updated to 2.64.2

* Mon Sep 30 2019 Jakub Bogusz <qboosh@pld-linux.org> 545e745
- updated to 2.62.0

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> 7700f46
- updated to 2.60.0

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> 8aa54ff
- drop .la files; release 3

* Thu Sep 05 2019 Jakub Bogusz <qboosh@pld-linux.org> b04e992
- explicit dll "soname"

* Sat Dec 22 2018 Jakub Bogusz <qboosh@pld-linux.org> 699199a
- release 2

* Thu Nov 08 2018 Jakub Bogusz <qboosh@pld-linux.org> 317dc93
- updated to 2.58.0

* Fri Oct 05 2018 Jakub Bogusz <qboosh@pld-linux.org> a99b542
- requires i486 atomic operations; release 2

* Fri Oct 05 2018 Jakub Bogusz <qboosh@pld-linux.org> 7bc3f17
- updated to 2.56.0

* Wed Jun 28 2017 Jakub Bogusz <qboosh@pld-linux.org> a69449b
- updated to 2.52.0

